package org.linotte.greffons.impl.swing;

import java.awt.Color;
import java.awt.Dimension;

import javax.swing.JComponent;
import javax.swing.JPanel;

import net.miginfocom.swing.MigLayout;

import org.linotte.frame.latoile.Couleur;
import org.linotte.greffons.externe.Composant;
import org.linotte.greffons.impl.swing.layout.GestionnairePlacement;

/**
 * 
 * @author R.M
 * 
 */
public class Panneau extends ComposantDeplacable {

	JPanel panneau;

	@Override
	public void initialisation() throws GreffonException {
		if (panneau != null) {
			super.initEvenement();
			return;
		}
		setVisible(getAttributeAsString("visible").equals("oui"));
		panneau = new JPanel();
		panneau = new JPanel(new MigLayout());

		// Position :
		x = getAttributeAsBigDecimal("x").intValue();
		y = getAttributeAsBigDecimal("y").intValue();
		// Dimensions :
		int hauteur = getAttributeAsBigDecimal("hauteur").intValue();
		int largeur = getAttributeAsBigDecimal("largeur").intValue();
		panneau.setPreferredSize(new Dimension(largeur, hauteur));
		panneau.setMaximumSize(new Dimension(largeur, hauteur));

		changerCouleurFond();
		super.initEvenement();
	}

	/**
	 * 
	 */
	private void changerCouleurFond() {
		String couleurfond = getAttributeAsString("couleurfond");
		if (couleurfond != null && couleurfond.trim().length() > 0) {
			Color c2 = Couleur.retourneCouleur(couleurfond);
			panneau.setOpaque(true);
			panneau.setBackground(c2);
		} else
			panneau.setOpaque(false);
		panneau.setVisible(isVisible());
	}

	@Override
	public void ajouterComposant(Composant pcomposant) throws GreffonException {

		// Cas des gestionnaires de placement :
		if (pcomposant instanceof GestionnairePlacement) {
			GestionnairePlacement gestionnairePlacement = (GestionnairePlacement) pcomposant;
			panneau.setLayout(gestionnairePlacement.retourneGestionnairePlacement());
			gestionnairePlacement.fairePere(this);
		} else {

			ComposantSwing composant = (ComposantSwing) pcomposant;
			ComposantDeplacable composantDeplacable = (ComposantDeplacable) composant;

			try {
				panneau.add(composantDeplacable.getJComponent(), "pos " + composantDeplacable.getX() + " " + composantDeplacable.getY());
			} catch (GreffonException e) {
				e.printStackTrace();
			}
			panneau.revalidate();
			composantDeplacable.setParent(this);
		}
	}

	@Override
	public JComponent getJComponent() throws GreffonException {
		return panneau;
	}

	@Override
	public boolean fireProperty(String clef) throws GreffonException {
		if (!super.fireProperty(clef)) {
			if (panneau != null && "couleurfond".equals(clef)) {
				changerCouleurFond();
				return true;
			}
		}
		return false;
	}

	@Override
	public void destruction() throws GreffonException {
		if (panneau != null) {
			// menu.dispose();
			panneau = null;
		}
	}

	@Override
	public boolean enregistrerPourDestruction() {
		return true;
	}

}
